#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/wait.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <stdlib.h>
#include <stdio.h>

#define KEYSEM1 1
#define KEYSEM2 2
#define KEYSEM3 3

void sinyal12(void)
{
}

void sem_signal(int semid, int val, int nsems)
{
  struct sembuf semafor;
  int i;

  semafor.sem_op=val;
  semafor.sem_flg=1;
  for (i=0; i<nsems; i++)
  {
    semafor.sem_num=i;
    semop(semid, &semafor,1);
  }
}

void sem_wait(int semid, int val, int nsems)
{
  struct sembuf semafor;
  int i;

  semafor.sem_op=(-1*val);
  semafor.sem_flg=1;
  for (i=0; i<nsems; i++)
  {
    semafor.sem_num=i;
    semop(semid, &semafor,1);
  }
}

int main (void)
{
  int sem,
      sonsem,
      c[2],
      f,
      i,
      siram;

  signal(12, (sighandler_t) sinyal12);


  for (i=0; i<2; i++)
  {
    f=fork();
    if (f==0)
      break;
    else
      c[i]=f;
  }
  if (f==-1)
  {
    printf("FORK hata....\n");
    exit(1);
  }

  if (f!=0)
  {
    printf("Anne kaynaklari yaratmaya basliyor....\n");
    sem=semget(KEYSEM1, 2, 0700|IPC_CREAT);
    semctl(sem, 0, SETVAL,1);
    semctl(sem, 1, SETVAL,1);

    sonsem=semget(KEYSEM3,1,0700|IPC_CREAT);
    semctl(sonsem,0,SETVAL,0);

    sleep(2);
    printf("Anne cocuklari baslatiyor .......\n");
    for (i=0; i<2; i++)
      kill(c[i],12);

    sem_wait(sonsem,2,1);

    printf("Anne: Cocuklarin isi bitti, kaynaklar iade ediliyor...\n");
    semctl(sonsem,0,IPC_RMID,0);
    semctl(sem,0,IPC_RMID,0);
    exit(0);
  }
  else
  {
    siram=i;
    printf("cocuk %d anneden haber bekliyor ....\n", siram);
    pause();
    sem=semget(KEYSEM1,2,0);
    sonsem=semget(KEYSEM3,1,0);
    printf("cocuk %d anneden haber aldi, basliyor ....\n", siram);

    printf("cocuk %d: sem eksiltiyorum.\n", siram);
    sem_wait(sem,1,2);
    printf("cocuk %d: kritik bolgemdeyim.\n", siram);
    sleep(5);    /* K.B. islemleri */
    sem_signal(sem,1,2);
    sem_signal(sonsem,1,1);
  }
  return 0;
}

